#include "include/synthAct.h"

microSynth::microSynth()
{
    LFO1toVO1 = false;
    LFO1toPO1 = false;
    LFO1toVO2 = false;
    LFO1toPO2 = false;
    LFO1toVO3 = false;
    LFO1toPO3 = false;
    LFO2toVO1 = false;
    LFO2toPO1 = false;
    LFO2toVO2 = false;
    LFO2toPO2 = false;
    LFO2toVO3 = false;
    LFO2toPO3 = false;
    noteOn = false;
    notePitch = 69;
    waveLFO1 = 0;
    waveLFO2 = 0;
    waveOSC1 = 0;
    waveOSC2 = 0;
    waveOSC3 = 0;
    ampValue = 1.0f;
    panValue = 0.5f;
    volOSC1 = 1.0f;
    panOSC1 = 0.5f;
    volOSC2 = 1.0f;
    panOSC2 = 0.5f;
    volOSC3 = 1.0f;
    panOSC3 = 0.5f;
    volLFO1 = 1.0f;
    freqLFO1 = 16.0f;
    volLFO2 = 1.0f;
    freqLFO2 = 16.0f;
    sample_Rate = 44100;
    maxEnvTime = 5000.0f;
    latency = 768;
    auralValue = 1.0f;
    noteOnCount = 0;
}

microSynth::~microSynth()
{

}

void microSynth::setLFO1wave(unsigned short int kind) {
    waveLFO1 = kind;
}

void microSynth::setLFO2wave(unsigned short int kind) {
    waveLFO2 = kind;
}

void microSynth::setOSC1wave(unsigned short int kind) {
    waveOSC1 = kind;
}

void microSynth::setOSC2wave(unsigned short int kind) {
    waveOSC2 = kind;
}

void microSynth::setOSC3wave(unsigned short int kind) {
    waveOSC3 = kind;
}

unsigned short int microSynth::getLFO1wave() {
    return waveLFO1;
}

unsigned short int microSynth::getLFO2wave() {
    return waveLFO2;
}

unsigned short int microSynth::getOSC1wave() {
    return waveOSC1;
}

unsigned short int microSynth::getOSC2wave() {
    return waveOSC2;
}

unsigned short int microSynth::getOSC3wave() {
    return waveOSC3;
}


void microSynth::isLFO1toVO1(bool value) {
    LFO1toVO1 = value;
}

void microSynth::isLFO2toVO1(bool value) {
    LFO2toVO1 = value;
}

void microSynth::isLFO1toVO2(bool value) {
    LFO1toVO2 = value;
}

void microSynth::isLFO2toVO2(bool value) {
    LFO2toVO2 = value;
}

void microSynth::isLFO1toVO3(bool value) {
    LFO1toVO3 = value;
}

void microSynth::isLFO2toVO3(bool value) {
    LFO2toVO3 = value;
}

void microSynth::isLFO1toPO1(bool value) {
    LFO1toPO1 = value;
}

void microSynth::isLFO2toPO1(bool value) {
    LFO2toPO1 = value;
}

void microSynth::isLFO1toPO2(bool value) {
    LFO1toPO2 = value;
}

void microSynth::isLFO2toPO2(bool value) {
    LFO2toPO2 = value;
}

void microSynth::isLFO1toPO3(bool value) {
    LFO1toPO3 = value;
}

void microSynth::isLFO2toPO3(bool value) {
    LFO2toPO3 = value;
}

unsigned int microSynth::getSampleRate() {
    return sample_Rate;
}

void microSynth::setSampleRate(unsigned int sRate) {
    sample_Rate = sRate;
}

void microSynth::setAmp(unsigned short int value) {
    ampValue = (float)value / 100.0f;
}

float microSynth::getAmp() {
    return ampValue;
}

void microSynth::setPan(unsigned short int value) {
    panValue = (float)value / 127.0f;
}

float microSynth::getPan() {
    return panValue;
}

void microSynth::setVolOSC1(unsigned short int value) {
    volOSC1 = (float)value / 100.0f;
}

float microSynth::getVolOSC1() {
    return volOSC1;
}

void microSynth::setPanOSC1(unsigned short int value) {
    panOSC1 = (float)value / 127.0f;
}

float microSynth::getPanOSC1() {
    return panOSC1;
}
void microSynth::setVolOSC2(unsigned short int value) {
    volOSC2 = (float)value / 100.0f;
}

float microSynth::getVolOSC2() {
    return volOSC2;
}

void microSynth::setPanOSC2(unsigned short int value) {
    panOSC2 = (float)value / 127.0f;
}

float microSynth::getPanOSC2() {
    return panOSC2;
}
void microSynth::setVolOSC3(unsigned short int value) {
    volOSC3 = (float)value / 100.0f;
}

float microSynth::getVolOSC3() {
    return volOSC3;
}

void microSynth::setPanOSC3(unsigned short int value) {
    panOSC3 = (float)value / 127.0f;
}

float microSynth::getPanOSC3() {
    return panOSC3;
}

void microSynth::setVolLFO1(unsigned short int value) {
    volLFO1 = (float)value / 100.0f;
}

float microSynth::getVolLFO1() {
    return volLFO1;
}

void microSynth::setFreqLFO1(unsigned short int value) {
    freqLFO1 = (float)value;
}

float microSynth::getFreqLFO1() {
    return freqLFO1;
}
void microSynth::setVolLFO2(unsigned short int value) {
    volLFO2 = (float)value / 100.0f;
}

float microSynth::getVolLFO2() {
    return volLFO2;
}

void microSynth::setFreqLFO2(unsigned short int value) {
    freqLFO2 = (float)value;
}

float microSynth::getFreqLFO2() {
    return freqLFO2;
}

bool microSynth::tellMeLFOtoOSC1(unsigned short int lfo, unsigned short int param) {
    switch (lfo) {
    case 1:
        {
            if (param == 1) return LFO1toVO1;
            if (param == 2) return LFO1toPO1;
        }
        break;
    case 2:
        {
            if (param == 1) return LFO2toVO1;
            if (param == 2) return LFO2toPO1;
        }
        break;
    default:
        {}
        ;
    }
}

bool microSynth::tellMeLFOtoOSC2(unsigned short int lfo, unsigned short int param) {
    switch (lfo) {
    case 1:
        {
            if (param == 1) return LFO1toVO2;
            if (param == 2) return LFO1toPO2;
        }
        break;
    case 2:
        {
            if (param == 1) return LFO2toVO2;
            if (param == 2) return LFO2toPO2;
        }
        break;
    default:
        {}
        ;
    }
}

bool microSynth::tellMeLFOtoOSC3(unsigned short int lfo, unsigned short int param) {
    switch (lfo) {
    case 1:
        {
            if (param == 1) return LFO1toVO3;
            if (param == 2) return LFO1toPO3;
        }
        break;
    case 2:
        {
            if (param == 1) return LFO2toVO3;
            if (param == 2) return LFO2toPO3;
        }
        break;
    default:
        {}
        ;
    }
}

void microSynth::setPitch(unsigned short int value) {
    notePitch = value;
}

int microSynth::getPitch() {
    return notePitch;
}

void microSynth::setControlVol(unsigned short int value) {
    controlVol = ((float)value / 100.0f);
}

float microSynth::getControlVol() {
    return controlVol;
}

void microSynth::setMaxEnvTime(float value) {
    maxEnvTime = value;
}

float microSynth::getMaxEnvTime() {
    return maxEnvTime;
}

void microSynth::setLatency(unsigned int value) {
    latency = value;
}

unsigned int microSynth::getLatency() {
    return latency;
}

void microSynth::setAuralValue(bool value) {
    if (value) auralValue = 1.618033988769f;
    else auralValue = 1.0f;
}

float microSynth::getAuralValue() {
    return auralValue;
}
